\ gpio --> gpio-2310.fs                                               MM-231013
\
\ VIS rp2040 GPIO Module for Mecrisp Stellaris
\
\ MIT License (C) 2023 manfred.mahlow@forth-ev.de
\ ------------------------------------------------------------------------------
  #require mask
  #require reg32

forth definitions decimal

  voc IO     \ words: BASE
  voc PADS   \ words: BASE
  voc SIO    \ words: BASE  GPIO
  voc GPIO   \ words: pad:  STATUS  CTRL  PAD

  IO definitions    $40014000 constant BASE  ( IO_BANK0_BASE )
  
  PADS definitions  $4001c000 constant BASE  ( PADS_BANK0_BASE )

  SIO definitions   $d0000000 constant BASE  ( SIO_BASE )

    voc GPIO   \ words: IN  OUT  OE

    SIO GPIO definitions

      voc IN   \ words: bi@
      voc OUT  \ words: bi@  bis  bic  bix
      voc OE   \ words: bi@  bis  bic  bix

      SIO GPIO IN definitions

        : bi@ ( mask -- x ) SIO BASE $004 + ( SIO_GPIO_IN ) @ and ;

      SIO GPIO OUT definitions

        : bi@ ( mask -- x ) SIO BASE $010 + ( SIO_GPIO_OUT ) @ and ;
        : bis ( mask -- ) SIO BASE $014 + ( SIO_GPIO_OUT_SET ) ! ;
        : bic ( mask -- ) SIO BASE $018 + ( SIO_GPIO_OUT_CLR ) ! ;
        : bix ( mask -- ) SIO BASE $01C + ( SIO_GPIO_OUT_XOR ) ! ;

      SIO GPIO OE definitions

        : bi@ ( mask -- x ) SIO BASE $020 + ( SIO_GPIO_QE ) @ and ;
        : bis ( mask -- ) SIO BASE $024 + ( SIO_GPIO_QE_SET ) ! ;
        : bic ( mask -- ) SIO BASE $028 + ( SIO_GPIO_QE_CLR ) ! ;
        : bix ( mask -- ) SIO BASE $02C + ( SIO_GPIO_QE_XOR ) ! ;

forth definitions

  GPIO definitions

  \ The rp2040 has 30 GPIOs, referred to by a number GPx, with 0 <= GPx <= 29 .

    : pad: ( "name" GPx -- )  \  name ( -- GPx , C: GPIO )
    \ Given a GPIO number GPx create a context switching constant that gives
    \ access to the GPIOs registers.
      item constant ;

      reg32ro item
    : STATUS ( GPx -- a ) 8 * IO BASE + ( IO_BANK0_GPIOx_STATUS ) ;

      reg32 item
    : CTRL ( GPx -- a ) GPIO STATUS 4 + ( IO_BANK0_GPIOx_CTRL ) ;

      reg32 item
    : PAD ( GPx -- a ) 1+ 4 * PADS BASE + ( PADS_BANK0_GPIOx ) ;

    \  PADS BASE $7C + constant SWCLK_PAD
    \  PADS BASE $80 + constant SWD_PAD

      SIO GPIO OUT item
    : OUT ( GPx -- mask ) mask ;

      SIO GPIO OE item
    : OE ( GPx -- mask ) mask ;

      SIO GPIO IN item
    : IN ( GPx -- mask ) mask ;

  forth definitions

\                    25 gpio oe bis            25 gpio out bis
\ 25 gpio pad: led       led oe bis            led out bis
\
\                    25 mask sio gpio oe bis   25 mask sio gpio out bis
\                              
\\ MM-231105



